function [sys,x0,str,ts] = relayfun(t,x,u,flag,sysname,Ms,method,action)

global relay initial1 initial2 t0 y0 v0 delay k kk y amp1 amp2
global per1 per2 Kc Ti

switch flag

  case 0
    [sys,x0,str,ts]=mdlInitializeSizes;
  
  case 3
    if relay==1
        if initial1==1
            t0=t;y0=u(1);v0=u(2);initial1=0;sys=0;
        else
            if initial2==1 && u(2)~=v0
                delay=t-t0;initial2=0;
            end
            y(k)=u(1);
            k=k+1;
            if u(2)~=v0
                if u(2)>0 && action==1 || u(2)<0 && action==-1
                    ymax=max(y);
                    amp1=ymax-y0;
                    per1=t-t0;
                    period=per1+per2;
                elseif u(2)>0 && action==-1 || u(2)<0 && action ==1
                    ymin=min(y);
                    amp2=y0-ymin;
                    per2=t-t0;
                    period=per1+per2;
               
                end
                amplitude=(amp1+amp2)/2;
                                                
                if kk==10
                    sys=1;relay=0;initial2=1;initial1=1;kk=1;
                    amp1=0;per1=0;amp2=0;per2=0;
                    
                    wu=2*pi/period; % Ultimate frequency
                    Kcu=4*abs(v0)/(pi*amplitude); % Ultimate gain
                    
                    disp(['Amp=',num2str(amplitude)])
                    disp(['Pu=',num2str(period)])
                    disp(['Delay=',num2str(delay)])
                    disp(['wu=',num2str(wu)])
                    disp(['Kcu=',num2str(Kcu)])
                                                         
                    if method==1
                        % PI tuning with ZN method
                        Kc=Kcu/2.2*action;
                        Ti=period/1.2;
                    elseif method==2
                        % PI tuning with TL method
                        Kc=Kcu/3.2*action;
                        Ti=period/0.45;
                    else
                         % Identification of a FOPDT model based on realy test
                        tp=tan(pi-delay*wu)/wu;
                        if tp<0
                            %1st estimate a SOPDT model
                            tp=tan((pi-delay*wu)/2)/wu;
                            Kp=(tp^2*wu^2+1)/Kcu;
                            % Now estimate a FOPDT model
                            tp=sqrt(Kcu^2*Kp^2-1)/wu;
                            delay=(pi-atan(tp*wu))/wu;
                        else
                            Kp=sqrt(tp^2*wu^2+1)/Kcu;
                        end
                        disp('FOPDT Parameters')
                        disp(['Gain=',num2str(Kp)])
                        disp(['Time Constant=',num2str(tp)])
                        disp(['Dead Time=',num2str(delay)])
                   
                        if method==3
                            % PI tuning with RIMC method
                            Tc0=max(1.7*delay,.2*tp);
                            Tc=Ms_Tc(Kp,delay,tp,Tc0,Ms,1,action);
                            Ti=tp+delay/2;
                            Kc=action*Ti/(Kp*Tc);
                        elseif method==4 
                            % PI tuning with SIMC method
                            Tc0=delay;
                            Tc=Ms_Tc(Kp,delay,tp,Tc0,Ms,2,action);
                            Ti=min(tp,4*(Tc+delay));
                            Kc=action*tp/(Kp*(Tc+delay));
                        else
                            % PI tuning with ISIMC method
                            Tc0=delay;
                            Tc=Ms_Tc(Kp,delay,tp,Tc0,Ms,3,action);
                            Ti=min(tp+delay/3,4*(Tc+delay));
                            Kc=action*(tp+delay/3)/(Kp*(Tc+delay));
                        end 
                        disp(['landa=',num2str(Tc)])
                    end
                    disp(['Kc=',num2str(Kc)])
                    disp(['Ti=',num2str(Ti)])
                    set_param(sysname,'SimulationCommand','update')
                    
                else
                    t0=t;v0=u(2);kk=kk+1;
                    sys=0;
                end
                k=1;clear global y 
            end
       end
        
    else
        sys=1;
    end

  
end


%
function [sys,x0,str,ts]=mdlInitializeSizes

%
% call simsizes for a sizes structure, fill it in and convert it to a
% sizes array.
%
% Note that in this example, the values are hard coded.  This is not a
% recommended practice as the characteristics of the block are typically
% defined by the S-function parameters.
%
sizes = simsizes;

sizes.NumContStates  = 0;
sizes.NumDiscStates  = 0;
sizes.NumOutputs     = 1;
sizes.NumInputs      = 2;
sizes.DirFeedthrough = 1;
sizes.NumSampleTimes = 1;   % at least one sample time is needed

sys = simsizes(sizes);

%
% initialize the initial conditions
%
x0  = [];

%
% str is always an empty matrix
%
str = [];

%
% initialize the array of sample times
%
ts  = [0 0];

% end mdlInitializeSizes

%
function sys=Ms_Tc(Kp,delay,tp,Tc0,Msd,method,action)
    n=100;
    w=logspace(-2,2,n); % Frequency vector (logarithmic)
    s=1i.*w;
    Tc=Tc0;

    % The value of process transfer function in each frequency
    Gp=Kp*exp(-delay*s)./(tp*s+1);
    for cc=1:1000
         % The value of controller transfer function in each frequency
         if method==1
             Ti=tp+delay/2;
             Gc=action*(tp+delay/2)/(Kp*Tc)*(1+1./(Ti*s));
         elseif method==2
             Ti=min(tp,4*(Tc+delay));
             Gc=action*tp/(Kp*(Tc+delay))*(1+1./(Ti*s));
         else
             Ti=min(tp+delay/3,4*(Tc+delay));
             Gc=action*(tp+delay/3)/(Kp*(Tc+delay))*(1+1./(Ti*s));
         end
         % The value of open loop transfer function in each frequency
         Gol=Gp.*Gc;
         % The value of Sensitivity function in each frequency
         S=1./(1+Gol);
         % Calculation of Ms
         Ms=max(abs(S));
         if abs(Ms-Msd)<.01,break,end
         Tc=Tc+.05;
    end
    
sys=Tc;

% end Ms_Tc
